<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <gusbeth@aol.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_myquizpoll_helper {

	var $maximumPoints;		// Total maximum points of all questions of a quiz
	var $numberQuestions;	// Number of all questions
	var $firsttime;			// Start time of the quiz
	var $pid;
	var $answerChoiceMax;
	var $tableQuestions;
	var $tableAnswers;
	var $tableRelation;
	var $setQuestionsBool = false;
	var $settings;
	var $cObj = null; // for making typo3 links
//	var $typoVersion; // TYPO3 version
		
	/* constructor */
	function tx_myquizpoll_helper($pid, $lang, $answerChoiceMax, $tableQuestions, $tableAnswers, $tableRelation, $settings) { 
		$this->pid 	= $pid;
		$this->lang = $lang;
		$this->answerChoiceMax = $answerChoiceMax;
		$this->tableQuestions 	= $tableQuestions;
		$this->tableAnswers		= $tableAnswers;
		$this->tableRelation 	= $tableRelation;
		$this->settings 		= $settings;
		$this->cObj 			= new tslib_cObj();
//		$this->typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);		
	}
	
	
	
  /**
    * Sets the starttime of a quiz
    */
	function setFirstTime($uid, $time) {
		$this->firsttime = $time;		
		if ($this->settings['userSession']) {
			$GLOBALS['TSFE']->fe_user->setKey('ses','firsttime'.$uid, $time);
		}
	}
	
	/**
    * Gets the starttime of a quiz
    */
	function getFirstTime($uid) {
		if ($uid) {
			$time = $this->firsttime;
			if (!$time && $this->settings['userSession']) {
				$time = $GLOBALS['TSFE']->fe_user->getKey('ses','firsttime'.$uid);
				$this->firsttime = $time;
			}
			if (!$time) {
				$res6 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('firsttime',
					$this->tableAnswers,
					'uid='.intval($uid).' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($this->tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res6);
				if ($rows>0) {							// DB entry found for current user?
					$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res6);
					$time = $fetchedRow['firsttime'];
				}
				mysql_free_result($res6);
				$this->firsttime = $time;
				if ($this->settings['userSession']) {
					$GLOBALS['TSFE']->fe_user->setKey('ses','firsttime'.$uid, $time);
				}
			}
		} else {
			$time = 0;
		}
		return intval($time);
	}
	
	
  /**
    * Calculate the total maximum points of all questions of a quiz and no. of all questions
    */
	function setQuestionsVars() {
		$maxPoints = 0;
		$noQuestions = 0;
		
		// Get all questions from the database
		$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				$this->tableQuestions,
				'pid='.$this->pid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($this->tableQuestions),
				'',
				'',
				'');
		$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
		if ($rows>0) {
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
				$noQuestions++;
				if (!$this->settings['dontShowPoints']) {
					$points = 0;
					$answPoints = 0;
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?
							if ($row['correct'.$answerNumber] || $row['qtype']==3) {
								$points+=intval($row['points']);
							}
							$tmpPoints = intval($row['points'.$answerNumber]);
							if ($tmpPoints) {
								if ($row['qtype'] == 0 || $row['qtype'] == 3) {
									$answPoints+=$tmpPoints;	// points for each answer
								} else if ($tmpPoints > $answPoints) {
									$answPoints=$tmpPoints;	// points for each answer
								}
							}
						}
					}
					if ($answPoints>0)
						$maxPoints+=$answPoints;
					else
						$maxPoints+=$points;
				}
			}
		}
		$GLOBALS['TYPO3_DB']->sql_free_result($res5);
		
		// doppelt speichern (falls jemand cookies nicht mag)
		$this->maximumPoints = $maxPoints;
		$this->numberQuestions = $noQuestions;
		if ($this->settings['userSession']) {
			$GLOBALS['TSFE']->fe_user->setKey('ses','maximumPoints', $maxPoints);
			$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestions', $noQuestions);
		}
		$this->setQuestionsBool = true;
    }
	
	function getQuestionsMaxPoints() {
		if ($this->settings['userSession'])
			$max = $GLOBALS['TSFE']->fe_user->getKey('ses','maximumPoints');
		else
			$max = 0;
		if (!$max && $this->setQuestionsBool)			// wenn keine cookies erlaubt sind...
			$max = $this->maximumPoints;
		else if (!$max && !$this->setQuestionsBool) {	// wenn setQuestionsVars noch nicht aufgerufen wurde
			$this->setQuestionsVars();
			$max = $this->maximumPoints;
		}
		if (!$max) $max = 0;						// wenn alles umsonst war...
		return $max;
	}
	
	// returns how many questios are there in the DB
	function getQuestionsNo() {
		if ($this->settings['userSession'])
			$no = $GLOBALS['TSFE']->fe_user->getKey('ses','numberQuestions');
		else
			$no = 0;
		if (!$no && $this->setQuestionsBool)			// wenn keine cookies erlaubt sind...
			$no = $this->numberQuestions;
		else if (!$no && !$this->setQuestionsBool) {	// wenn setQuestionsVars noch nicht aufgerufen wurde
			$this->setQuestionsVars();
			$no = $this->numberQuestions;
		}
		if (!$no) $no = 0;							// wenn alles umsonst war...
		return $no;
	}
	
	// returns who many questions have been answered yet
	function getQuestionNo($answered) {
		if ($answered=='-') {
			if ($this->settings['userSession'])
				$no = $GLOBALS['TSFE']->fe_user->getKey('ses','numberQuestion');
			else $no = 0;		// unknown
			if ($no==='') $no = 0;	// unknown
		} else if (!$answered) {
			$no = 0;
			if ($this->settings['userSession'])
				$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestion', $no);
		} else {		// mind. 1 Frage wurde beantwortet oder uebersprungen!
			$no = substr_count($answered, ',') + 1;
			if ($this->settings['userSession'])
				$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestion', $no);
		}
		return $no;
	}
	
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_helper.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_helper.php']);
}

?>
